
#include <i86.h>
#include <dos.h>
#include <math.h>
#include <stdio.h>
#include <stdlib.h>
#include <conio.h>

#include "vdt.h"
#include "global.h"
#include "cpart1.h"


//-------------------------------------------------------------------------------------
//-------------------------------------------------------------------------------------

int cpart1::Startup() {


 picture.Create(320,200);
#ifdef datafile
 dl.Seek("oko.pcx");
 picture.Load(dl.LibFile);
 dl.Seek("oko.pal");
 picpal.Load(dl.LibFile);
#else
 picture.Load("..\\data\\oko.pcx");
 picpal.Load("..\\data\\oko.pal");
#endif
 picture.Remap(&picpal.pal);


 picture2.Create(1008,243);
#ifdef datafile
 dl.Seek("ghetto.pcx");
 picture2.Load(dl.LibFile);
#else
 picture2.Load("..\\data\\ghetto.pcx");
#endif
 picture2.Remap(&picpal.pal);

 text1.Create(320,59);
#ifdef datafile
 dl.Seek("text2.pcx");
 text1.Load(dl.LibFile);
#else
 text1.Load("..\\data\\text2.pcx");
#endif
 text1.Remap(&picpal.pal);

 text2.Create(210,107);
#ifdef datafile
 dl.Seek("presents.pcx");
 text2.Load(dl.LibFile);
#else
 text2.Load("..\\data\\presents.pcx");
#endif
 text2.Remap(&picpal.pal);

 text3.Create(400,119);
#ifdef datafile
 dl.Seek("pest1.pcx");
 text3.Load(dl.LibFile);
#else
 text3.Load("..\\data\\pest1.pcx");
#endif

 return Success;
}


//-------------------------------------------------------------------------------------
//-------------------------------------------------------------------------------------

int cpart1::Init() {

 virtscr.Create(320,200);
 frames=0;
 //printf("init OK\n");
 return Success;
}

//-------------------------------------------------------------------------------------
//-------------------------------------------------------------------------------------

int cpart1::Terminate() {

 picture.Destroy();
 picture2.Destroy();
 text1.Destroy();
 text2.Destroy();
 text3.Destroy();

 return Success;
}


//-------------------------------------------------------------------------
//-------------------------------------------------------------------------

void  cpart1::scrolltext(int x) {
 int ofset1,i;
 int pixels;

 for(i=0;i<59;i++){
  ofset1=i*320;
  memcpy(virtscr.Data+ofset1+(320-x)+82*320,text1.Data+ofset1,x);
 }
}

//-------------------------------------------------------------------------------
//-------------------------------------------------------------------------------

void cpart1::scrollleft(unsigned int x){
 int ofset1,i;
 int ofset2;
 int pixels;

 for(i=0;i<243;i++){
  ofset1=i*640;
  ofset2=1008*i;
  pixels=1008-x;
  if (pixels>640) pixels=640;
  memcpy(virtscr.Data+ofset1,picture2.Data+ofset2+x,pixels);
 }
}

//-------------------------------------------------------------------------
//-------------------------------------------------------------------------

void cpart1::scrollright(int aktpos,unsigned int x){
 int ofset1,i;
 int pos=aktpos-x;
 int ofset2;
 int  pixels;

 for(i=0;i<243;i++){
  ofset1=i*640;
  ofset2=i*1008;
  pixels=1008-pos;
  if (pixels>640) pixels=640; 
  memcpy(virtscr.Data+ofset1,picture2.Data+ofset2+pos,pixels);
 }
}

//-------------------------------------------------------------------------------------
//-------------------------------------------------------------------------------------

int cpart1::Run() {
 int i,k,next;
 int aktposic;

 // the first part.
 // the video mode is initialized here
 //printf("part1 RUN\n");


 svga.Init(mode_320x200);
 svga.Clear();
 svga.SetPalette(&picpal.pal);

 frames=frameCount=0;
 do{
   scrolltext(frameCount);
   svga.Copy(&virtscr,0,0);
   if (exitflag==1) return Error;
   check();
   virtscr.Clear();
 } while (frameCount<300);


 scrolltext(299);


 origpal.Load(&picture);

 for (k=0; k<256; k++) {
  pompal.pal[k].r=64;
  pompal.pal[k].g=64;
  pompal.pal[k].b=64;
 }

 memcpy(virtscr.Data,picture.Data,64000);
 //write text
 virtscr.TCopy(&text1,20,82);


 //reset timer
 frames=frameCount=0;
 do{
  for (k=0; k<256; k++) {
   if (pompal.pal[k].r > origpal.pal[k].r) pompal.pal[k].r--;
   if (pompal.pal[k].g > origpal.pal[k].g) pompal.pal[k].g--;
   if (pompal.pal[k].b > origpal.pal[k].b) pompal.pal[k].b--;
  }
  svga.SetPalette(&pompal.pal);
  svga.Copy(&virtscr,0,0);
  //if keypress
  if (exitflag==1) return Error;
  check();
 } while (frameCount<64);


 //reset timer
 frames=frameCount=0;

 //wait 300 ticks , see picture with text
 do{
  frames=frameCount;
  if (exitflag==1) return Error;
  check();
 }while (frames<300);


 svga.Init(mode_640x480);
 svga.Clear();
 virtscr.Destroy();
 virtscr.Create(640,480);
 virtscr.Clear();
 picpal.Load(&picture2);
 origpal.Load(&picture2);


 for (k=0; k<256; k++) {
  pompal.pal[k].r=64;
  pompal.pal[k].g=64;
  pompal.pal[k].b=64;
 }

 text2.Remap(&picpal.pal);

 //reset timer
 i=frames=frameCount=0;
 do{
  if (i<64) {
   for (k=0; k<256; k++) {
    if (pompal.pal[k].r > origpal.pal[k].r) pompal.pal[k].r--;
    if (pompal.pal[k].g > origpal.pal[k].g) pompal.pal[k].g--;
    if (pompal.pal[k].b > origpal.pal[k].b) pompal.pal[k].b--;
   }
  }
  svga.SetPalette(&pompal.pal);
  scrollleft(frameCount);
  virtscr.Copy(&text2,120,270);
   svga.Copy(&virtscr,0,0);
  //if keypress
  if (frameCount>frames){
   frames=frameCount;
   i++;
  }
  if (exitflag==1) return Error;
  check();
 } while (frameCount<(1008-640));

 text3.Remap(&picpal.pal);

 aktposic=frameCount;

 //reset timer
 i=frames=frameCount=0;
 do{
  scrollright(aktposic,frameCount);
  virtscr.TCopy(&text3,120,270);
  svga.Copy(&virtscr,0,0);
  //if keypress
  if (exitflag==1) return Error;
  check();
  virtscr.Clear();
  if (frameCount>frames){
   frames=frameCount;
   i++;
  }
 } while (frameCount<(1008-640));

 int pos;
 do{
 if (exitflag==1) return Error;
 check();
 de.music.GetInfo();
 pos=de.music.info->position;
 } while (pos<5);


 return Success;
}

//-------------------------------------------------------------------------------------
//-------------------------------------------------------------------------------------

int cpart1::Done() {

 virtscr.Destroy();

 return Success;
}

//-------------------------------------------------------------------------------------
//-------------------------------------------------------------------------------------


