
#include <i86.h>
#include <dos.h>
#include <math.h>
#include <stdio.h>
#include <stdlib.h>
#include <conio.h>

#include "vdt.h"
#include "global.h"
#include "cpart2.h"



// --------------------------------------------------------------------------
// --------------------------------------------------------------------------

void filter_small(char* src, char* dest);
#pragma aux filter_small = \
        "mov ecx,4000" \
        "mov edx,80" \
        "cld" \
        "et: " \
        "  lodsd" \
        "  stosb" \
        "  dec edx" \
        "  jg okay" \
        "    mov edx,80" \
        "    add esi,960" \
        "okay:" \
        "  dec ecx" \
        "jnz et" \
        parm [esi] [edi] \
        modify [eax ecx edx esi edi];


//-------------------------------------------------------------------------------------
//-------------------------------------------------------------------------------------

int cpart2::Startup() {

	world.light.ambient = 30;
	world.light.max     = 60;
	world.light.FollowCamera = YES;
	world.camera.Move(0,0,0);
	world.camera.SetAngles(0,0,0);
	world.camera.zoom = 1;
	world.SetHaze (1024);
     #ifdef datafile
	dl.Seek("tower.pal");
	world.pal.Load(dl.LibFile);
	dl.Seek("tower.shd");
	world.shade.Load(dl.LibFile);
     #else
	world.pal.Load("..\\data\\tower.pal");
	world.shade.Load("..\\data\\tower.shd");
     #endif

     #ifdef datafile
	dl.Seek("tower.vsc");
	world.MergeMesh("scene1",dl.LibFile);
	dl.Seek("satelite.lmx");
	world.MergeHalo("halo",dl.LibFile);
     #else
	world.MergeMesh("scene1","..\\data\\tower.vsc");
	world.MergeHalo("halo","..\\data\\satelite.lmx");
     #endif
	world.SetTwoSided(ON);

        //-- [ PATH INIT ] ------------------------------------------------
     #ifdef datafile
	dl.Seek("tower.pth");
	fread((void*)step,1,dl.ActualSize(),dl.LibFile);
	steps = dl.ActualSize()/sizeof(steps_struct);
     #else
	FILE* f = fopen("..\\data\\tower.pth","rb");
	int delka=filesize(f);
	fread((void*)step,1,delka,f);
	fclose(f);
	steps = delka/sizeof(steps_struct);
     #endif
	compute_movie();

	// --- [ TEXTURES ] ------------------------------------------------
     #ifdef datafile
	dl.Seek("textura1.pcx");
	textura1.Load(dl.LibFile);
     #else
	textura1.Load("..\\data\\textura1.pcx");
     #endif
	textura1.Remap(&world.pal.pal);
        textura1.Resample(256,256);

     #ifdef datafile
	dl.Seek("metal.pcx");
	textura2.Load(dl.LibFile);
     #else
	textura2.Load("..\\data\\metal.pcx");
     #endif
	textura2.Remap(&world.pal.pal);

	pestsp.Create(100,100);
     #ifdef datafile
	dl.Seek("pestsp.pcx");
	pestsp.Load(dl.LibFile);
     #else
	pestsp.Load("..\\data\\pestsp.pcx");
     #endif
	pestsp.Remap(&world.pal.pal);

	return Success;
}


//-------------------------------------------------------------------------------------
//-------------------------------------------------------------------------------------

int cpart2::Init() {

	// setup halo
        halo = (Halo*)world.SelectObject("halo");
	halo->SetHaloSize(0.3);
	halo->SetLensEffect(YES,10,0.3);
	halo->SetVisibility(Visible);
     #ifdef datafile
	dl.Seek("lens007.lns");
	halo->LoadLens(dl.LibFile);
     #else
	halo->LoadLens("..\\data\\lens007.lns");
     #endif
        halo->SetLensFlare(14);


	obj = (Mesh*)world.SelectObject("scene1");

	obj->SetFlags(ShadingGouraud | MappingTextured); // gouraud!
	obj->SetTexture(&textura1);
	world.Scale(1,1,1);
	obj->SetTwoSided(OFF);

	star=(Chunk*)obj->SelectChunk("Object01");
	star->SetTwoSided(ON);
	star->SetFlags(ShadingGouraud | MappingTextured);
	star->SetTexture(&textura2 );
	frames=0;
	virtscr.Create(320,200);
	small.Create(80,50);

	return Success;

}

//-----------------------------------------------------------------------------
//-----------------------------------------------------------------------------

long cpart2::filesize(FILE *stream) {
   long curpos, length;

   curpos = ftell(stream);
   fseek(stream, 0L, SEEK_END);
   length = ftell(stream);
   fseek(stream, curpos, SEEK_SET);
   return length;
}

//-----------------------------------------------------------------------------
//--------------------------------------------------------------------------------

void cpart2::compute_movie() {

	frames=0;
	float pas = (float)1/(float)maxpp2;
        for (int k=1; k<steps-1; k++) {
                float t = 0;
		for (int i=0; i<maxpp2; i++) {
                        path[frames].x = bspline( step[k-1].x, step[k].x, step[k+1].x, t );
                        path[frames].y = bspline( step[k-1].y, step[k].y, step[k+1].y, t );
                        path[frames].z = bspline( step[k-1].z, step[k].z, step[k+1].z, t );
                        path[frames].a = bspline( step[k-1].a, step[k].a, step[k+1].a, t );
                        path[frames].b = bspline( step[k-1].b, step[k].b, step[k+1].b, t );
                        path[frames].c = bspline( step[k-1].c, step[k].c, step[k+1].c, t );
                        frames++;
                        t += pas;
                }
        }
 celkanim=frames;
 //printf("%d %d %d",steps,celkanim,maxpp2);
 //getch();
}

//--------------------------------------------------------------------------------
//-----------------------------------------------------------------------------

void cpart2::see_picture (float x, float y, float z, float a, float b, float c) {

	world.camera.Move(x,y,z);
	world.camera.Rotate(a,b,c);
	virtscr.Clear();
	world.FlashCamera(&virtscr);
}

//--------------------------------------------------------------------------------
//-----------------------------------------------------------------------------

int cpart2::Terminate() {

	world.Destroy();
	textura1.Destroy();
	textura2.Destroy();
	pestsp.Destroy();

	return Success;
}

//-------------------------------------------------------------------------------------
//-------------------------------------------------------------------------------------

int cpart2::Done(){
 virtscr.Destroy();
 small.Destroy();

 return Success;
}

//-------------------------------------------------------------------------------------
//-------------------------------------------------------------------------------------

int cpart2::Run() {
int error;
unsigned synch;
 //in part1 last mode was 640x480

 if (exitflag==1) return Error;
   check();

 svga.Init(mode_320x200);
 //if ( (error = tmrStopScrSync()) != 0 ) return Error;
 //if ( (error = tmrGetScrSync(&synch)) != 0 ) return Error;
 //if ( (error = tmrSyncScr(synch, &mytimer, NULL, NULL)) != 0 ) return Error;
 svga.Clear();
 virtscr.Clear();
 svga.SetPalette(&world.pal.pal);

 // camera initial params ***********************
 float cax, cay, caz, cx, cy, cz;
 obj->Rotate(0,0,0); // bugfix for some bug in envmapping in 3d-engine :(

 star->Move(-12,1142,0.51);
 halo->Move(0,880,-170);

 //reset timer
 aktframe=0;
 frames=frameCount=0;
 do {
   // camera stuff
   cx = path[frameCount].x;
   cy = path[frameCount].y;
   cz = path[frameCount].z;
   cax = path[frameCount].a;
   cay = path[frameCount].b;
   caz = path[frameCount].c;
   star->Rotate(anglex,0,anglex);

   // take a picture
   see_picture (cx,cy,cz,cax,cay,caz);

   // display everything
   filter_small(virtscr.Data, small.Data);
   virtscr.Copy(&small, 220, 20);

   if (frameCount>200 && frameCount<(celkanim-300))
    virtscr.TCopy(&pestsp,0,0);

   svga.Copy(&virtscr,0,0);
   anglex=frameCount*pi/120;
   if (exitflag==1) return Error;
   check();
 } while  (frameCount<celkanim);

 return Success;
}

//-------------------------------------------------------------------------------------
//-------------------------------------------------------------------------------------


