
#include <i86.h>
#include <dos.h>
#include <math.h>
#include <stdio.h>
#include <stdlib.h>
#include <conio.h>

#include "vdt.h"
#include "global.h"
#include "cpart5.h"

//-------------------------------------------------------------------------------------
//-------------------------------------------------------------------------------------

void filter5_small(char* src, char* dest);
#pragma aux filter5_small = \
        "mov ecx,4000" \
        "mov edx,80" \
        "cld" \
        "et: " \
        "  lodsd" \
        "  stosb" \
        "  dec edx" \
        "  jg okay" \
        "    mov edx,80" \
        "    add esi,960" \
        "okay:" \
        "  dec ecx" \
        "jnz et" \
        parm [esi] [edi] \
        modify [eax ecx edx esi edi];

//-------------------------------------------------------------------------------------
//-------------------------------------------------------------------------------------

int cpart5::Startup() {


	//-- [ WORLD INIT ] -----------------------------------------------
	world.light.ambient = 10;
	world.light.max     = 40;
	world.light.FollowCamera = YES;
	world.camera.Move(0,0,0);
	world.camera.SetAngles(0,0,0);
	world.camera.zoom = 1;
	world.ShowHiddenFaces = NO;
    #ifdef datafile
	dl.Seek("huba.pal");
	world.pal.Load(dl.LibFile);
	dl.Seek("huba.shd");
	world.shade.Load(dl.LibFile);
    #else
	world.pal.Load("..\\data\\huba.pal");
	world.shade.Load("..\\data\\huba.shd");
    #endif

    #ifdef datafile
	dl.Seek("cubes.vsn");
	world.MergeMesh("obiect",dl.LibFile);
    #else
	world.MergeMesh("obiect","..\\data\\cubes.vsn");
    #endif

    #ifdef datafile
	dl.Seek("l003.lmx");
	world.MergeHalo("halo0",dl.LibFile);
	dl.Seek("l003.lmx");
	world.MergeHalo("halo1",dl.LibFile);
	dl.Seek("l003.lmx");
	world.MergeHalo("halo2",dl.LibFile);
	dl.Seek("l003.lmx");
	world.MergeHalo("halo3",dl.LibFile);
	dl.Seek("l003.lmx");
	world.MergeHalo("halo4",dl.LibFile);
    #else
	world.MergeHalo("halo0","..\\data\\l003.lmx");
	world.MergeHalo("halo1","..\\data\\l003.lmx");
	world.MergeHalo("halo2","..\\data\\l003.lmx");
	world.MergeHalo("halo3","..\\data\\l003.lmx");
	world.MergeHalo("halo4","..\\data\\l003.lmx");
    #endif

	//-- [ PATH INIT ] ------------------------------------------------
    #ifdef datafile
	dl.Seek("cubes.pth");
	fread((void*)step,1,dl.ActualSize(),dl.LibFile);
	steps = dl.ActualSize()/sizeof(steps_struct);
    #else
	FILE* f = fopen("..\\data\\cubes.pth", "rb");
	fseek(f,0,2); long fsize = ftell(f); fseek(f,0,0);
	fread ((void*)step, 1, fsize, f);
	fclose(f);
	steps = fsize / sizeof(steps_struct);
    #endif
	compute_movie();
	// --- [ TEXTURES ] ------------------------------------------------
	//tex_back.Load("data//filter.pcx");

    #ifdef datafile
	dl.Seek("huba.pcx");
	tex_back.Load(dl.LibFile);
    #else
	tex_back.Load("..\\data\\huba.pcx");
    #endif
	tex_back.Remap(&world.pal.pal);
	tex_back.Resample(256,256);

	pestdr.Create(100,100);
    #ifdef datafile
	dl.Seek("pestdr.pcx");
	pestdr.Load(dl.LibFile);
    #else
	pestdr.Load("..\\data\\pestdr.pcx");
    #endif
	pestdr.Remap(&world.pal.pal);

	return Success;
}


//-------------------------------------------------------------------------------------
//-------------------------------------------------------------------------------------

int cpart5::Init() {
int trany=150;
int tranx=90;
int tranz=70;

	// --- [ PREPARING HALO LIGHTS ] ------------------------------------

	// setup halo #0
	h0 = (Halo*)world.SelectObject("halo0");
	h0->SetHaloSize(0.2);
      #ifdef datafile
	dl.Seek("lens006.lns");
	h0->LoadLens(dl.LibFile);
      #else
	h0->LoadLens("..\\data\\lens006.lns");
      #endif
	h0->SetLensEffect(YES,4,0.10);
	h0->SetLensFlare(20);
	h0->SetVisibility(Visible);
	h0->Move(0,0,0);
	h0->RealTranslate(0,trany,0);

	// setup halo #1
	h1 = (Halo*)world.SelectObject("halo1");
	h1->SetHaloSize(0.2);
	h1->SetLensEffect(NO,4,0.10);
	h1->SetLens(h0->lens);
	h1->SetLensFlare(15);
	h1->SetVisibility(Visible);
	h1->Move(0,0,0);
	h1->RealTranslate(tranx,trany,0);

	// setup halo #2
	h2 = (Halo*)world.SelectObject("halo2");
	h2->SetHaloSize(0.2);
	h2->SetLensEffect(NO,4,0.10);
	h2->SetLens(h0->lens);
	h2->SetLensFlare(15);
	h2->SetVisibility(Visible);
	h2->Move(0,0,0);
	h2->RealTranslate(-tranx,trany,0);

	// setup halo #3
	h3 = (Halo*)world.SelectObject("halo3");
	h3->SetHaloSize(0.2);
	h3->SetLensEffect(NO,4,0.10);
	h3->SetLens(h0->lens);
	h3->SetLensFlare(15);
	h3->SetVisibility(Visible);
	h3->Move(0,0,0);
	h3->RealTranslate(0,trany,tranz);

	// setup halo #4
	h4 = (Halo*)world.SelectObject("halo4");
	h4->SetHaloSize(0.2);
	h4->SetLensEffect(NO,4,0.10);
	h4->SetLens(h0->lens);
	h4->SetLensFlare(15);
	h4->SetVisibility(Visible);
	h4->Move(0,0,0);
	h4->RealTranslate(0,trany,-tranz);


	// --- [ PREPARING OBJECTS ] ----------------------------------------

	obj = (Mesh*)world.SelectObject("obiect");
	obj->SetVisibility(Visible);
	obj->SetFlags(ShadingFlat | MappingTextured);
	obj->SetTexture(&tex_back); //!?
	//obj->Scale(0.4,0.4,0.4);
	obj->Move(0,0,0);

  virtscr.Create(320,200);
  small.Create(80,50);
  angle=0;

  return Success;

}

//-----------------------------------------------------------------------------
//-----------------------------------------------------------------------------

long cpart5::filesize(FILE *stream) {
   long curpos, length;

   curpos = ftell(stream);
   fseek(stream, 0L, SEEK_END);
   length = ftell(stream);
   fseek(stream, curpos, SEEK_SET);
   return length;
}

//-----------------------------------------------------------------------------
//--------------------------------------------------------------------------------

void cpart5::compute_movie() {

	frames=0;
	float pas = (float)1/(float)maxpp5;
        for (int k=1; k<steps-1; k++) {
                float t = 0;
		for (int i=0; i<maxpp5; i++) {
                        path[frames].x = bspline( step[k-1].x, step[k].x, step[k+1].x, t );
                        path[frames].y = bspline( step[k-1].y, step[k].y, step[k+1].y, t );
                        path[frames].z = bspline( step[k-1].z, step[k].z, step[k+1].z, t );
                        path[frames].a = bspline( step[k-1].a, step[k].a, step[k+1].a, t );
                        path[frames].b = bspline( step[k-1].b, step[k].b, step[k+1].b, t );
                        path[frames].c = bspline( step[k-1].c, step[k].c, step[k+1].c, t );
                        frames++;
                        t += pas;
                }
        }
 celkanim=frames;
 //printf("%d %d %d",steps,celkanim,maxpp5);
 //getch();
}

//--------------------------------------------------------------------------------
//-----------------------------------------------------------------------------

void cpart5::see_picture (float x, float y, float z, float a, float b, float c) {

	world.camera.Move(x,y,z);
	world.camera.Rotate(a,b,c);
	virtscr.Clear();
	world.FlashCamera(&virtscr);
}

//--------------------------------------------------------------------------------
//-----------------------------------------------------------------------------

int cpart5::Terminate() {
	world.Destroy();
	tex_back.Destroy();
	pestdr.Destroy();

	return Success;
}

//-------------------------------------------------------------------------------------
//-------------------------------------------------------------------------------------

int cpart5::Done(){

 virtscr.Destroy();
 small.Destroy();
 return Success;

}

//-------------------------------------------------------------------------------------
//-------------------------------------------------------------------------------------

int cpart5::Run() {

  if (exitflag==1) return Error;
   check();

  svga.Init(mode_320x200);
  svga.Clear();
  virtscr.Clear();

  float hx = 0;
  float hy = 0;
  float hz = 0;


  // camera initial angles ***********************
  float cax = 0;
  float cay = 0;
  float caz = 0;

  // camera initial position *********************
  float cx = 0;
  float cy = 0;
  float cz = -100;

   obj->Rotate(0,0,0); // bugfix for some bug in envmapping in 3d-engine :(
   svga.SetPalette(&world.pal.pal);
   frames=frameCount=0;
   int pos;
   do {
     angle=frameCount*pi/150;
     h0->Rotate(0,3*angle,0);
     h1->Rotate(0,3*angle,0);
     h2->Rotate(0,3*angle,0);
     h3->Rotate(0,3*angle,0);
     h4->Rotate(0,3*angle,0);
     hx = 33.7 + 30*cos(-angle);
     hy = 40; // ?!
     hz = -62  + 30*sin(-angle);
     h0->Move(hx,hy,hz);
     h1->Move(hx,hy,hz);
     h2->Move(hx,hy,hz);
     h3->Move(hx,hy,hz);
     h4->Move(hx,hy,hz);

     cx = path[frameCount].x;
     cx = path[frameCount].x;
     cy = path[frameCount].y;
     cz = path[frameCount].z;
     cax = path[frameCount].a;
     cay = path[frameCount].b;
     caz = path[frameCount].c;
     if (frameCount>(celkanim-1)) {
      cx = path[celkanim-(frameCount-celkanim)].x;
      cy = path[celkanim-(frameCount-celkanim)].y;
      cz = path[celkanim-(frameCount-celkanim)].z;
      cax = path[celkanim-(frameCount-celkanim)].a;
      cay = path[celkanim-(frameCount-celkanim)].b;
      caz = path[celkanim-(frameCount-celkanim)].c;
     }

     // take a picture
     see_picture (cx,cy,cz,cax,cay,caz);

     filter5_small(virtscr.Data, small.Data);
     //virtscr.Copy(&small,0,0);


     if (frameCount>1000 && frameCount<(celkanim-3000))
      virtscr.TCopy(&pestdr,220,100);

     // display everything
     svga.Copy(&virtscr,0,0);
     if (exitflag==1) return Error;
     check();
     de.music.GetInfo();
     pos=de.music.info->position;
   } while (pos<0x3E);


 return Success;

}

//-------------------------------------------------------------------------------------
//-------------------------------------------------------------------------------------


