
#include <i86.h>
#include <dos.h>
#include <math.h>
#include <stdio.h>
#include <stdlib.h>
#include <conio.h>

#include "vdt.h"
#include "global.h"
#include "cpart6.h"

//-------------------------------------------------------------------------------------
//-------------------------------------------------------------------------------------

int cpart6::Startup() {

 int i;

 virtscr1.Create(320,200);
 virtscr2.Create(320,200);
 virtscr3.Create(320,200);
 mask2.Create(320,200);
 memset(virtscr1.Data,0,64000);
 memset(virtscr2.Data,0,64000);
 memset(virtscr3.Data,0,64000);

 //loading textures
 texture.Create(256,256);
#ifdef datafile
 dl.Seek("glow.pcx");
 texture.Load(dl.LibFile);
 dl.Seek("glow.pal");
 mypal.Load(dl.LibFile);
#else
 texture.Load("..\\data\\glow.pcx");
 mypal.Load("..\\data\\glow.pal");
#endif
 texture.Remap(&mypal.pal);
   
 //initial warp path
 for(i=0;i<(2*64);i++) {
  warppthx[i]=1;
  if (i<=63) warppthy[i]=1;
  else warppthy[i]=0; 
 }

 for(i=(2*64);i<(4*64);i++) {
  warppthx[i]=0;
  if (i<=(3*63)) warppthy[i]=0;
  else warppthy[i]=1; 
 }

 for(i=(4*64);i<(6*64);i++) {
  warppthx[i]=1;
  if (i<=(5*63)) warppthy[i]=1;
  else warppthy[i]=0; 
 }

 for(i=(6*64);i<(8*64);i++) {
  warppthx[i]=0;
  if (i<=(7*63)) warppthy[i]=0;
  else warppthy[i]=1; 
 }

 //loading transition tanble for transparency
#ifdef datafile
 dl.Seek("spring.trt");
 fread((void*)transition_table,1,dl.ActualSize(),dl.LibFile);
#else
 FILE *f;
 f = fopen("..\\data\\spring.trt", "rb");
 fseek(f,0,2); long fsize = ftell(f); fseek(f,0,0);
 fread ((void*)transition_table, 1, fsize, f);
 fclose(f);
#endif

 //loading mask,shading table
 mask.Create(320,200);
#ifdef datafile
 dl.Seek("hub320bw.pcx");
 mask.Load(dl.LibFile);
 dl.Seek("glow.shd");
 shd.Load(dl.LibFile);
#else
 mask.Load("..\\data\\hub320bw.pcx");
 shd.Load("..\\data\\glow.shd");
#endif

 code.Create(100,100);
#ifdef datafile
 dl.Seek("code.pcx");
 code.Load(dl.LibFile);
#else
 code.Load("..\\data\\code.pcx");
#endif
 code.Remap(&mypal.pal);

 engine.Create(140,100);
#ifdef datafile
 dl.Seek("engine.pcx");
 engine.Load(dl.LibFile);
#else
 engine.Load("..\\data\\engine.pcx");
#endif
 engine.Remap(&mypal.pal);

//prep tunel procedure cut and past

 preptunel();

 return Success;

}


//-------------------------------------------------------------------------------------
//-------------------------------------------------------------------------------------

void cpart6::preptunel(void)
{

 int x,y;
 float ang,dst,z=207;
 int maxang=1024;
 float zdec=0.7;
 float angdec=0.8;
 float prec=pi/(maxang/2);
 char pom1,pom2; 

/* 
 FILE *in;
 
 if ( (in=fopen("textura1.data","rb")) == NULL )
        {
                printf("Ooops cannot open texture file");
                exit(1);                
        }
 fread(texture.Data,65535,1,in);
 fclose(in);
*/

 ang=maxang-1;
 dst=1;
 do{
  x=z*sin(ang*prec)+160; 
  y=z*cos(ang*prec)*0.8+100; 
  ang=ang-angdec;
  if (ang<0) {
   ang+=maxang;
   dst+=dst*0.02;
   z-=zdec;
  }
  if ((x>=0) && (x<320) && (y>=0) && (y<200)) {
   pom1=dst;pom2=(dst-(float)ang/4.0);
   memcpy(virtscr1.Data+x+y*320,&pom1,1);
   memcpy(virtscr2.Data+x+y*320,&pom2,1);
   pom1=*(virtscr1.Data+x+y*320);
   pom2=*(virtscr2.Data+x+y*320);
   memcpy(virtscr3.Data+x+y*320,texture.Data+256*pom1+pom2,1);
  }
 } while (z>0);
}

//-------------------------------------------------------------------------------------
//-------------------------------------------------------------------------------------

void cpart6::drawTunel(char movement)
{
 int i;
 unsigned int pom;
 
 for(i=0;i<64000;i++){
  pom=((*(virtscr1.Data+i)+movement)<<8)+*(virtscr2.Data+i);
  if (pom>65536) pom-=65536; //!!!!!!!!!!!!!!!!VERY IMPORTANT
  memcpy(virtscr.Data+i,texture.Data+pom,1);
 }
}

//-------------------------------------------------------------------------------------
//-------------------------------------------------------------------------------------

int cpart6::Init() {

  virtscr.Create(320,200);
  memcpy(virtscr.Data,virtscr3.Data,64000);
  return Success;

}

//--------------------------------------------------------------------------------
//-----------------------------------------------------------------------------

int cpart6::Terminate() {

 virtscr1.Destroy();
 virtscr2.Destroy();
 mask.Destroy();
 mask2.Destroy();
 texture.Destroy();
 code.Destroy();
 engine.Destroy();

 return Success;

}

//-------------------------------------------------------------------------------------
//-------------------------------------------------------------------------------------

int cpart6::Done(){

 virtscr.Destroy();
 return Success;

}

//-------------------------------------------------------------------------------------
//-------------------------------------------------------------------------------------

void part6_raise (char* src, int cnt, char ampl, char* trtab, char* dest);
#pragma aux part6_raise = \
            "and edx,0xffff                     " \
            "loop1:                             " \
            "  mov dl,[esi]                     " \
            "  and dl,0x3f                      " \
            "  mov dh,ah                        " \
            "  shl dh,6                         " \
            "  or dl,dh                         " \
            "  mov dh,ah                        " \
            "  shr dh,2                         " \
            "  mov al,[ebx+edx]                 " \
            "  mov [edi],al                     " \
            "  inc edi                          " \
            "  inc esi                          " \
            "dec ecx                            " \
            "jnz loop1                          " \
            parm [esi] [ecx] [ah] [ebx] [edi] \
            modify [eax ecx edx esi edi];

//-------------------------------------------------------------------------------------
//-------------------------------------------------------------------------------------

void part6_apply(char*, char*, int, char*);
#pragma aux part6_apply = \
            "mov eax,0                          " \
            "loop2:                             " \
            "  mov al,[edi]                     " \
            "  mov ah,[esi]                     " \
            "  mov al,[ebx+eax]                 " \
            "  mov [edi],al                     " \
            "  inc esi                          " \
            "  inc edi                          " \
            "dec ecx                            " \
            "jnz loop2                          " \
            parm [esi] [edi] [ecx] [ebx] \
            modify [eax ecx esi edi];

void cpart6::tran(int frm, int frmcnt, int ampl)
{
        float ang = pi * (float)frm / (float)frmcnt;
        int   kkk = (int)((float)ampl * sin(ang));
        if (kkk>32) kkk = 32;
        virtscr.Brightness((32-(kkk>>1)),shd.shadetab);
	part6_raise(mask.Data, 64000, (char)kkk, transition_table, mask2.Data);
	part6_apply(mask2.Data, virtscr.Data, 64000, shd.shadetab);
}

//-------------------------------------------------------------------------------------
//-------------------------------------------------------------------------------------

int cpart6::Run() {

  if (exitflag==1) return Error;
   check();

  svga.Init(mode_320x200);
  svga.Clear();
  virtscr.Clear();


  svga.SetPalette(&mypal.pal);

  int pos;
  frameCount=0;
  do {
   drawTunel(frameCount);

   if ( (frameCount >= 180) && (frameCount <= 680) ) {
    //tran(frame-80/*frameno*/, 200/*framecnt*/, 32/*maxamplitude*/);
    tran(frameCount-180/*frameno*/, 500/*framecnt*/, 10/*maxamplitude*/);
   virtscr.TCopy(&engine,0,0);
   }

   if ( (frameCount >= 1000) && (frameCount <= 1500) ) {
    //tran(frame-80/*frameno*/, 200/*framecnt*/, 32/*maxamplitude*/);
    tran(frameCount-1000/*frameno*/, 500/*framecnt*/, 100/*maxamplitude*/);
   virtscr.TCopy(&code,0,0);
   }


   svga.Copy(&virtscr,0,0);
   if (exitflag==1) return Error;
   check();
   de.music.GetInfo();
   pos=de.music.info->position;
 } while (pos<0x22);


/*
 getch();
 tnmv=0;
 do {
  drawTunel(tnmv+=2);
  svga.Copy(&virtscr,0,0);

  if (warppthx[cnt]) MoveLeft();
   else MoveRight();

  if (warppthy[cnt]) MoveDown();
   else MoveUp();

  if (cnt++>8*64) cnt=0;
 } while (!kbhit());
*/

  return Success;

}

//-------------------------------------------------------------------------------------
//-------------------------------------------------------------------------------------
